# Running the Course

> This page is for the course instructor.

Here is a bit of background information about how we've been running the course
internally at Google.

Before you run the course, you will want to:

1. Make yourself familiar with the course material. We've included speaker notes
   to help highlight the key points (please help us by contributing more speaker
   notes!). When presenting, you should make sure to open the speaker notes in a
   popup (click the link with a little arrow next to "Speaker Notes"). This way
   you have a clean screen to present to the class.

1. Decide on the dates. Since the course takes at least three full days, we recommend that you
   schedule the days over two weeks. Course participants have said that
   they find it helpful to have a gap in the course since it helps them process
   all the information we give them.

1. Find a room large enough for your in-person participants. We recommend a
   class size of 15-25 people. That's small enough that people are comfortable
   asking questions --- it's also small enough that one instructor will have
   time to answer the questions. Make sure the room has _desks_ for yourself and for the
   students: you will all need to be able to sit and work with your laptops.
   In particular, you will be doing a lot of live-coding as an instructor, so a lectern won't
   be very helpful for you.

1. On the day of your course, show up to the room a little early to set things
   up. We recommend presenting directly using `mdbook serve` running on your
   laptop (see the [installation instructions][3]). This ensures optimal performance with no lag as you change pages.
   Using your laptop will also allow you to fix typos as you or the course
   participants spot them.

1. Let people solve the exercises by themselves or in small groups.
   We typically spend 30-45 minutes on exercises in the morning and in the afternoon (including time to review the solutions).
   Make sure to
   ask people if they're stuck or if there is anything you can help with. When
   you see that several people have the same problem, call it out to the class
   and offer a solution, e.g., by showing people where to find the relevant
   information in the standard library.

That is all, good luck running the course! We hope it will be as much fun for
you as it has been for us!

Please [provide feedback][1] afterwards so that we can keep improving the
course. We would love to hear what worked well for you and what can be made
better. Your students are also very welcome to [send us feedback][2]!

[1]: https://github.com/google/comprehensive-rust/discussions/86
[2]: https://github.com/google/comprehensive-rust/discussions/100
[3]: https://github.com/google/comprehensive-rust#building
